%
% Exemple de FEM per elements lineals: LINK
% (2-Dim: desplaaments en x i y)
%
% (c) Toni Susin, 2012
%-----------------------------------------------------------


%------------------------------------
% Carreguem la geometria: nodes i elements
%------------------------------------
nod=load('nodes2.txt','-ascii');
[num_nod,ndim]=size(nod);
%Matriu de connectivitat
B=load('conectivitat2.txt','-ascii');
elem=B; %son la mateixa cosa
[num_elem,ndim_elem]=size(elem);

%------------------------------------
%Pintem els nodes i els elements
%------------------------------------
figure(1)
pintemNodElem(nod,elem);
%------------------------------------
%Propietats del material
%------------------------------------
% mdul de Young
Y=50;
E=Y*ones(1, num_elem); %tots els elements del mateix material
E(3)=100;
%------------------------------------
%Constants reals: Area de secci de la barra
%------------------------------------
Area=2;
A=Area*ones(1,num_elem);
A(2)=1;
A(3)=2*sqrt(2);
%------------------------------------
%Pintem la matriu de rigidesa
%------------------------------------
figure(2)
K=zeros(num_nod*ndim);
for e=1:num_elem
    Ke=PlaneLinkBar_Mrigidesa(nod,elem,e,E,A)
    files=[elem(e,1)*2-1; elem(e,1)*2; elem(e,2)*2-1; elem(e,2)*2];
    colums=files;    
    K(files,colums)=K(files,colums)+Ke;
    spy(K)
    pause(0.1);
end
%matriu de rigidesa
K
%------------------------------------
% SOLVE: Apliquem condicions de contorn
%------------------------------------
%Inicialitzem forces
f=zeros(num_nod*ndim,1);
fixed=zeros(1,num_nod*ndim);
val=zeros(1,num_nod*ndim);
fapp=zeros(num_nod*ndim,1);

% Fixem els punts: 1 all DOF, 3 
% codifiquem amb un 1 els punts en els que fixem desplaaments
% exemp: fixed=[1,1,0,1,0,0];
fixed(1*ndim-1)=1; %(u1_x=0)
fixed(1*ndim)=1; %(u1_y=0)
fixed(2*ndim)=1; %(u2_y=0)
% codifiquem les forces i els valors dels desplaaments
% exemp: val=[0,0,0,0,2,1];
% forces al node 3 : (fx=2, fy=1)
nodf=3; %node en el que apliquem la fora
val(nodf*ndim-1)=2;
val(nodf*ndim)=1;
fapp(nodf*ndim-1)=2;
fapp(nodf*ndim)=1;
[Km,fm]=ImposemCC(K,f,fixed,val);
Km
fm
%------------------------------------
% SOLVE: Resolem el sistema i calculem els desplaaments
%------------------------------------

u=Km\fm

%------------------------------------
% POSTPROCES: Pintem desplaaments i calculem forces i tensions
%------------------------------------

% Representem la soluci desplaada
figure(3)
esc=2; %escala per representar els desplaaments
pintemNodElemDespl(nod,elem,u,esc);
%Forces de Reacci
fr=K*u-fapp
%Tensions Axials
[T, F]=calculTensionsAxials(nod,elem,u,E,A)



