% pont.m
% -----------------------------------------------------------------------
% Pr\`actica 1: 
% C\`alcul de les deformacions i tesions axials en l'estructura d'un pont
%------------------------------------------------------------------------
% Exemple de FEM per elements lineals: LINK
% (2-Dim: despla\c{c}aments en x i y)
%
% (c) Toni Susin, 2012
%-------------------------------------------------------------------------

% IMPORTANT: aquest codi \'es una modificaci\'o trivial de FemBar2D.m 
% ((c) Toni Sus\'{\i}n, 2012) a la Pr\`actica 1. Les funcions cridades des
% d'aquest script són del mateix autor.

% Assegureu-vos de tenir aquests fitxers al mateix directori:
%  pintemNodElem.m
%  PlaneLinkBar_Mrigidesa.m
%  ImposemCC.m
%  pintemNodElemDespl.m
%  calculTensionsAxials.m
%
% Tamb\'e haureu de crear dos fitxers de text:
%  nodes.txt
%  connctivitat.txt
%
% amb la posició dels nodes i la matriu de connectivitat dels elements,
% segons el format que es va explicar a classe.
 
%------------------------------------
% Carreguem la geometria: nodes i elements
%------------------------------------
nod=load('nodes.txt','-ascii'); % Per al pont
[num_nod,ndim]=size(nod);
B=load('connectivitat.txt','-ascii');
elem=B; %son la mateixa cosa
[num_elem,ndim_elem]=size(elem);

%------------------------------------
%Pintem els nodes i els elements
%------------------------------------
figure(1)
pintemNodElem(nod,elem);
%------------------------------------
%Propietats del material
%------------------------------------
Y=2E5; % N/mm^2
E=Y*ones(1, num_elem); %tots els elements del mateix material

%------------------------------------
%Constants reals: \`Area de secci\'o de la barra
%------------------------------------
Area=3250; % mm^2
A=Area*ones(1,num_elem); % Totes les barres amb la mateixa secci\'o

%------------------------------------
%Pintem la matriu de rigidesa
%------------------------------------
figure(2)
K=zeros(num_nod*ndim);
for e=1:num_elem
    Ke=PlaneLinkBar_Mrigidesa(nod,elem,e,E,A)
    files=[elem(e,1)*2-1; elem(e,1)*2; elem(e,2)*2-1; elem(e,2)*2];
    colums=files;    
    K(files,colums)=K(files,colums)+Ke;
    spy(K)
    pause(0.1);
end
%matriu de rigidesa
K
%------------------------------------
% SOLVE: Apliquem condicions de contorn
%------------------------------------
%Inicialitzem forces
f=zeros(num_nod*ndim,1);
fixed=zeros(1,num_nod*ndim);
val=zeros(1,num_nod*ndim);
fapp=zeros(num_nod*ndim,1);
 
% codifiquem amb un 1 els punts en els que fixem despla\c{c}aments

% Node 1 (ux, uy fixats)
fixed(1*ndim-1)=1;
fixed(1*ndim)=1;   
% Node 4 (ux lliure, uy fixat)
fixed(4*ndim)=1; 
%----------------------------------

% codifiquem les forces i els valors dels despla\c{c}aments
nodf=1 %apliquem la for\c{c}a en el node 1
val(nodf*ndim-1)=0;
val(nodf*ndim)=-2.8E5;
nodf=2 %apliquem la for\c{c}a en el node 2 
val(nodf*ndim-1)=0;
val(nodf*ndim)=-2.1E5;
nodf=3 %apliquem la for\c{c}a en el node 3
val(nodf*ndim-1)=0;
val(nodf*ndim)=-2.8E5;
nodf=4 %apliquem la for\c{c}a en el node 4
val(nodf*ndim-1)=0;
val(nodf*ndim)=-3.6E5;

fapp=val'; %copiem les forces imposades

% fixem despla\c{c}aments
% Node 1 (ux=0, uy=0)
val(1*ndim-1)=0;
val(1*ndim)=0;
% Node 4 (uy=0)
val(4*ndim)=0;

[Km,fm]=ImposemCC(K,f,fixed,val);
Km
fm
%------------------------------------
% SOLVE: Resolem el sistema i calculem els despla�aments
%------------------------------------

u=Km\fm

%------------------------------------
% POSTPROCES: Pintem despla�aments i calculem forces i tensions
%------------------------------------

% Representem la soluci� despla�ada
figure(3)
esc=10; %escala per representar els despla�aments
pintemNodElemDespl(nod,elem,u,esc);
%Forces de Reacci�
fr=K*u-fapp
%Tensions Axials
[T, F]=calculTensionsAxials(nod,elem,u,E,A)



